Qore WebUtil Module Reference: WebUtil::FileHandler Class Reference

Qore WebUtil Module Reference 1.1

- Main Page
- Related Pages
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Groups Pages
Public Member Functions | Public Attributes | Private Member Functions | List of all members
WebUtil::FileHandler Class Reference

this class serves files from the file system based on a root location More...

Inheritance diagram for WebUtil::FileHandler:
[legend]

## Public Member Functions
| constructor (string file_root, string url_root="/", *hash opt)
| create the object optionally with the given AbstractAuthenticator More...
private hash | fileError (hash cx, hash sh)
| this method returns a 400 `"Bad Request"` error code when a file should be served that's not a regular file More...
hash | handleRequest (hash cx, hash hdr, *data body)
| this method calls handleRequestImpl() to service the request, if handleRequestImpl() returns NOTHING, then it tries to automatically serve a matching template or files from the filesystem or serve the default resource if no resource can be matched More...
private *hash | handleRequestImpl (reference cx, hash hdr, *data body)
| this method is called by this class's handleRequest() before trying to service the request automatically based on file resources More...
| logDebug (string fmt)
| default implementation is empty; this method is called with debug log messages; reimplement in subclasses to provide for logging
| logError (string fmt)
| default implementation is empty; this method is called with error log messages; reimplement in subclasses to provide for logging
| logInfo (string fmt)
| default implementation is empty; this method is called with informational log messages; reimplement in subclasses to provide for logging
*hash | renderDirectory (hash cx, string path)
| this method is called when a directory should be rendered More...
private hash | serverError (hash cx, hash ex)
| this method returns a 500 `"Internal Server Error"` error code when an exception occurs More...
private hash | unhandledRequest (hash cx, hash hdr, *data body)
| this method returns a 404 `"Not Found"` error code to `GET` requests and a 501 `"Not Implemented"` error code to all other requests More...

## Public Attributes
*string | default_target
| the default target if a URL cannot be satisfied
const | Defaults
| default configuration values
const | Dirlisting
| dirlisting template
const | DirSep = (Unix ? "/" : "\\")
| directory separator character
softint | error_level = 0
| set for error info level More...
string | file_root
| root directory for serving files
softlist | indexes = (Defaults.IndexTemplate, Defaults.IndexFile)
| indexes for directories; handled in order of appearance
hash | template_extensions = Defaults.TemplateExtensions
| file extensions handled as templates
const | Unix = (PlatformOS != "Windows")
| flag for UNIX operating systems

## Private Member Functions
StaticTemplateManager | stm ()
| static templates
Private Member Functions inherited from WebUtil::TemplateFileManager
| constructor (int po=TextTemplateBase::DefaultProgramOptions, *code psetup)
| creates the object with optional Program options More...
| purge (string tname)
| this method can be called when a resource is requested that no longer exists in case a template is stored for a file that was deleted
hash | render (string tname, string path, date mtime, hash ctx, int code=200, *hash hdr)
| explicitly renders the given template with the given path and context argument More...

## Detailed Description

this class serves files from the file system based on a root location

## Member Function Documentation

WebUtil::FileHandler::constructor | ( | string | file_root,
|  | string | url_root = `"/"`,
|  | *hash | opt
| ) |  |

create the object optionally with the given AbstractAuthenticator

Parameters

  file_root | the filesystem root directory for serving files
  url_root | the root part of the URL path without the leading `"/"`
  options | an optional with one or more of the following option keys: `default_target:` the default relative path to use if a request cannot be satisfied `po:` the Program parse options for the template file programs `psetup:` an optional closure or call reference taking a single Program argument to be called when initializing template programs to set up a custom template API, etc `auth:` the authentication object to use to authenticate connections (see AbstractAuthenticator); if no AbstractAuthenticator object is passed, then by default no authentication will be required `error_level:` the level of error reporting (0, 1, or 2)

private hash WebUtil::FileHandler::fileError | ( | hash | cx,
|  | hash | sh
| ) |  |

this method returns a 400 `"Bad Request"` error code when a file should be served that's not a regular file

this method is called when a file cannot be served because it's not a regular file; reimplement this method in subclasses to customize error handling

hash WebUtil::FileHandler::handleRequest | ( | hash | cx,
|  | hash | hdr,
|  | *data | body
| ) |  |

this method calls handleRequestImpl() to service the request, if handleRequestImpl() returns NOTHING, then it tries to automatically serve a matching template or files from the filesystem or serve the default resource if no resource can be matched

Parameters

  cx | call context hash; this hash will have the following keys: `socket:` the bind address used to bind the listener (`"socket-info"` provides more detailed information) `socket-info`: a hash of socket information for the listening socket (as returned by Qore::Socket::getSocketInfo()) `peer-info`: a hash of socket information for the remote socket (as returned by Qore::Socket::getPeerInfo()) `url:` a hash of broken-down URL information (as returned from Qore::parse_url()) `id:` the unique HTTP connection ID `listener-id`: the HTTP server listener ID (see HttpServer::HttpServer::getListenerInfo()) `user:` the current RBAC username (if any)
  hdr | incoming header hash; all keys will be converted to lower-case, additionally the following keys will be present: `method:` the HTTP method received (ie `"GET"`, `"POST"`, etc) `path:` the HTTP path given in the request, after processing by Qore::decode_url() `http_version:` the HTTP version number in the request (either `"1.0"` or `"1.1"`)
  body | message body, if any

Returns
  a hash with the following keys:
  - `"code"`: the HTTP return code (see HttpServer::HttpServer::HttpCodes)
  - `"body"`: the message body to return in the response
  - `"close"`: (optional) set this key to True if the connection should be unconditionally closed when the handler returns
  - `"hdr"`: (optional) set this key to a hash of extra header information to be returned with the response

The following keys are added to the cx argument when calling handleRequestImpl():

- `resource_path:` the relative path without any query arguments and with the URL root stripped off (if the request was matched by the URL root, otherwise this will be the request path with any URI query arguments removed)
- `url_root:` the root URL
- `file_root:` the root directory for serving files
- `isregex:` if the url_root string is a regular expression or not (this is always False when this class is used)
- `hdr:` this is added to the cx argument directly from the hdr argument, however it also includes the `"params"` key which holds the URI query parameters as returned in the params key from HttpServer::parse_uri_query()

If handleRequestImpl() returns NOTHING and the requested path cannot be matched and served, then unhandledRequest() is called to handle the error

private *hash WebUtil::FileHandler::handleRequestImpl | ( | reference | cx,
|  | hash | hdr,
|  | *data | body
| ) |  |

this method is called by this class's handleRequest() before trying to service the request automatically based on file resources

Parameters

  cx | call context hash; this hash will have the following keys: `socket:` the bind address used to bind the listener (`"socket-info"` provides more detailed information) `socket-info`: a hash of socket information for the listening socket (as returned by Qore::Socket::getSocketInfo()) `peer-info`: a hash of socket information for the remote socket (as returned by Qore::Socket::getPeerInfo()) `url:` a hash of broken-down URL information (as returned from Qore::parse_url()) `id:` the unique HTTP connection ID `listener-id`: the HTTP server listener ID (see HttpServer::HttpServer::getListenerInfo()) `user:` the current RBAC username (if any) `resource_path:` the relative path without any query arguments and with the URL root stripped off (if the request was matched by the URL root, otherwise this will be the request path with any URI query arguments removed) `url_root:` the root URL `file_root:` the root directory for serving files `isregex:` if the url_root string is a regular expression or not (this is always False when this class is used) `hdr:` this is a copy of the hdr argument, however it also includes the `"params"` key which holds the URI query parameters as returned in the params key from HttpServer::parse_uri_query()
  hdr | incoming header hash; all keys will be converted to lower-case, additionally the following keys will be present: `method:` the HTTP method received (ie `"GET"`, `"POST"`, etc) `path:` the HTTP path given in the request, after processing by Qore::decode_url() `http_version:` the HTTP version number in the request (either `"1.0"` or `"1.1"`) `params:` holds the URI query parameters as returned in the params key from HttpServer::parse_uri_query()
  body | message body, if any

Returns
  a hash with the following keys:
  - `"code"`: the HTTP return code (see HttpServer::HttpServer::HttpCodes)
  - `"body"`: the message body to return in the response
  - `"close"`: (optional) set this key to True if the connection should be unconditionally closed when the handler returns
  - `"hdr"`: (optional) set this key to a hash of extra header information to be returned with the response

Note
  - this method has the following additional keys in the cx hash: `resource_path`, `url_root`, and `isregex`
  - the default implementation simply returns NOTHING all requests; reimplement this method in a subclass to provide the required functionality

*hash WebUtil::FileHandler::renderDirectory | ( | hash | cx,
|  | string | path
| ) |  |

this method is called when a directory should be rendered

if this method returns NOTHING then any default_target will be used, so to turn off directory rendering, subclass this class and have the reimplemented method return NOTHING

private hash WebUtil::FileHandler::serverError | ( | hash | cx,
|  | hash | ex
| ) |  |

this method returns a 500 `"Internal Server Error"` error code when an exception occurs

this method is called when an exception occurs; reimplement this method in subclasses to customize error handling

private hash WebUtil::FileHandler::unhandledRequest | ( | hash | cx,
|  | hash | hdr,
|  | *data | body
| ) |  |

this method returns a 404 `"Not Found"` error code to `GET` requests and a 501 `"Not Implemented"` error code to all other requests

this method is called when a request cannot be handled; reimplement this method in subclasses to customize unhandled request error handling

## Member Data Documentation

softint WebUtil::FileHandler::error_level = 0

set for error info level

The following are valid error levels:

- 0: no details
- 1: error summary info
- 2: complete error details including stack trace (can expose internal implementation details)